#include "main.h"

int 
is_in_the_game(void) {
    return (gs.connect_state >= IN_THE_GAME);
}

int 
is_connected(void) {
    return (gs.connect_state >= CONNECTED);
}

void 
init_quake_connection(void)
{
  int i;

  for(i=0; i<MAX_PLAYERS; i++) {
    gs.players[i].real_name[0] = '\0';
    gs.players[i].name[0]      = '\0';
    gs.players[i].frags        = 0;
    gs.players[i].shirt        = 0;
    gs.players[i].pants        = 0;
    gs.players[i].just_entered = FALSE;
    gs.players_old[i].valid    = FALSE;
  }

  queue_init(&gs.send_reliable_queue);
  queue_init(&gs.send_unreliable_queue);

  gs.connect_state             = NOT_CONNECTED;
  gs.server_socket             = 0;
  gs.keepalive_count           = 0;
  gs.signon_level              = 0;
  gs.player_number             = 0;

  gs.print_buf[0]              = '\0';
  gs.stuff_buf[0]              = '\0';
  gs.ban_lock                  = FALSE;

  gs.time                      = 0.0;

  gs.send_reliable_number      = 0;
  gs.send_unreliable_number    = 0;
  gs.recv_reliable_number      = 0;
  gs.recv_unreliable_number    = 0;

  gs.recv_buffer_pos           = 0;
}

void 
empty_send_queues(void)
{
    while( !queue_empty(&gs.send_reliable_queue) ) {
       packet_destroy((packet_t *)queue_remove(&gs.send_reliable_queue));
    }
    while( !queue_empty(&gs.send_unreliable_queue) ) {
       packet_destroy((packet_t *)queue_remove(&gs.send_unreliable_queue));
    }
}

void 
reset_connection(void) 
{
    net_close_socket(gs.server_socket);
    empty_send_queues();
    init_quake_connection();
}

void 
connect_quake_server(void)
{
    debug_set_lib("QSMACK");

    if( is_connected() ) {
      send_disconnect();
    } else if( gs.server_socket ) {
      reset_connection();
    }

    gs.server_addr            = net_name_to_address(gs.server_name);
    gs.server_port            = ntohs(gs.server_addr.sin_port);
    gs.server_socket          = net_open_socket(SOCK_DGRAM);
    net_connect_socket(gs.server_socket, &gs.server_addr, (short)gs.server_port);
    
    gs.connect_state          = CONNECTED;

    print_to_log("Trying to connect to %s\n", net_address_to_name(&gs.server_addr));
    send_to_clients("print Trying to connect to %s\n", net_address_to_name(&gs.server_addr));
    send_connection_request();
}
